#!/bin/bash

WIDTH=$1
HEIGHT=$2
SVGFILE=$3
TARGET=$4

usage()
{
	echo "$0 <width> <height> <SVG file> <target file>"
	echo "Example: $0 1024 768 background.svg /home/user/wallpapers/1024x768.png"
	exit 1
}

if [ -z "$4" ] || [ -n "$5" ]
then
	usage
fi

rsvg -a -w ${WIDTH} -h ${HEIGHT} -f png ${SVGFILE} ${SVGFILE}.png

NEWSIZE=`identify ${SVGFILE}.png | awk '{print $3}'`

NEWWIDTH=`echo ${NEWSIZE} | awk -F 'x' '{print $1}'`
NEWHEIGHT=`echo ${NEWSIZE} | awk -F 'x' '{print $2}'`

CROPWIDTH=$(( (NEWWIDTH - WIDTH) / 2 ))
CROPHEIGHT=$(( (NEWHEIGHT - HEIGHT) / 2 ))

if [ $CROPWIDTH -lt 0 ]
then
	rsvg -a -w ${WIDTH} -f png ${SVGFILE} ${SVGFILE}.png

	NEWSIZE=`identify ${SVGFILE}.png | awk '{print $3}'`

	NEWWIDTH=`echo ${NEWSIZE} | awk -F 'x' '{print $1}'`
	NEWHEIGHT=`echo ${NEWSIZE} | awk -F 'x' '{print $2}'`

	CROPWIDTH=$(( (NEWWIDTH - WIDTH) / 2 ))
	CROPHEIGHT=$(( (NEWHEIGHT - HEIGHT) / 2 ))
fi

convert -crop ${WIDTH}x${HEIGHT}+${CROPWIDTH}+${CROPHEIGHT} ${SVGFILE}.png ${TARGET}

rm -f ${SVGFILE}.png
